import javax.swing.JPanel;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.*;
import javax.swing.BorderFactory;

public class ElementComponent extends JPanel implements AbstractComponent{

    // Text areas for element name and content.
    javax.swing.JTextField elementName = new javax.swing.JTextField();
    javax.swing.JTextField elementContent = new javax.swing.JTextField();
    public boolean selected = false;
    public boolean exists = false;

    // Constructor
    public ElementComponent(){
	exists = true;
	super.setSize(new java.awt.Dimension(146, 30));
        super.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
        //super.setLocation(p);
        super.setVisible(true);
        super.setLayout(null);
        super.setToolTipText("Area for entering element details.");
        super.setBackground(java.awt.Color.lightGray);
	super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
        // event handling for the element component
        super.addMouseListener(new java.awt.event.MouseAdapter() {
                public void mouseClicked(java.awt.event.MouseEvent e) {
                    elementComponentMouseClicked(e);
                }
            });


        elementName.setToolTipText("Element name");
        elementName.setVisible(true);
        elementName.setSize(new java.awt.Dimension(60, 20));
        elementName.setSelectedTextColor(java.awt.SystemColor.textHighlight);
        elementName.setColumns(80);
        elementName.setBackground(java.awt.Color.lightGray);
        elementName.setLocation(new java.awt.Point(10, 5));
	elementName.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));

        elementContent.setToolTipText("Element content");
        elementContent.setVisible(true);
        elementContent.setSize(new java.awt.Dimension(60, 20));
        elementContent.setSelectedTextColor(java.awt.SystemColor.textHighlight);
        elementContent.setColumns(80);
        elementContent.setBackground(java.awt.Color.white);
        elementContent.setLocation(new java.awt.Point(80, 5));
	elementContent.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));

	this.add(elementName);
	this.add(elementContent);

    }

    public void rearrange(){}

    public void setName(String s){
	elementName.setText(s);
    }

    public void setContent(String s){
	elementContent.setText(s);
    }

    public void setLocation(Point p){
	super.setLocation(p);
    }

    public void setSize(java.awt.Dimension d){
	super.setSize(d);
    }

    public Dimension getSize() {
	return super.getSize();
    }

    public void add(AbstractComponent a){
	if (selected == true){
	    System.out.println("Cannot add stuff to elements ");
	}

    }
    
    public void toggleSelect(){
	if (selected){
	    selected = false;
	    //super.setBackground(new java.awt.Color(255,153,0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	    repaint();
	} else {
	    selected = true;
	    //super.setBackground(new java.awt.Color(255,153,100));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
	    repaint();
	}
    }

    public String genQuery() {
	String name, content;
	name = elementName.getText();
	content = elementContent.getText();
	if (content.equals("")){
	    return("(Elem \"" + name + "\" [])");
	} else {
	    return("(Elem \"" + name + "\" [(EText \"" + content + "\")])");
	}

    }

    // updateClick makes sure this Object does not get deleted unless specifically selected
    public void updateClick(){
        selected = false;
    }


    //public void mouseEntered(MouseEvent e){ }
    //public void mouseExited(MouseEvent e){ }
    //public void mousePressed(MouseEvent e){ }
    //public void mouseReleased(MouseEvent e){ }


    public void elementComponentMouseClicked(MouseEvent e){
	//System.out.println("Element clicked: " + selected);
	if (selected){
	    selected = false;
	    //super.setBackground(new java.awt.Color(255,153,0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	    repaint();
	} else {
	    selected = true;
	    //super.setBackground(new java.awt.Color(255,153,100));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
	    repaint();
	}
    }

    public void moved(AbstractComponent a){}

    public boolean isSelected(){
	return selected;
    }

    public void erase(){}

}
	
